// Call RunUserMacro(kTRUE) to run in compiled mode and see the error
// RunUserMacro(kFALSE) will run in interpreted mode

#if !defined(__CINT__) || defined(__MAKECINT__)

#include "TMethodCall.h"

#endif

TMethodCall* fUserMacro;

Int_t CallUserMacro(Int_t flag);

void RunUserMacro(Bool_t Compile=kTRUE,const char* fUserMacroName="UMacro.C")
{
  const int ntrial = 3;
  TString tmpst = fUserMacroName;
  if (Compile) tmpst += "++"; // Run in the compiled mode
  gROOT->LoadMacro(tmpst.Data());
  fUserMacro = new TMethodCall(); 
  tmpst.Resize(tmpst.First('.'));
  fUserMacro->InitWithPrototype(tmpst.Data(),"Int_t");
  //
  int val = -1;
  for (int i=0;i<ntrial;i++) {
    printf("Calling User Macro with flag %d\n",val);
    int res = CallUserMacro(val);
    printf("Execute(User Macro) returned %d\n\n",res);
    val++;
  }
}

//_____________________________________________
Int_t CallUserMacro(Int_t flag)
{
  Long_t res=0;
  if (fUserMacro) {
    fUserMacro->SetParamPtrs(&flag);
    fUserMacro->Execute(res);
  }
  return (Int_t) res;
}

//_____________________________________________
